org.apache.commons.collections4.map

## Class TransformedMap<K,V>

- java.lang.Object
- - org.apache.commons.collections4.map.AbstractIterableMap<K,V>
  - - org.apache.commons.collections4.map.AbstractMapDecorator<K,V>
    - - org.apache.commons.collections4.map.TransformedMap<K,V>

- Type Parameters:
    `K` - the type of the keys in this map
    `V` - the type of the values in this map
  All Implemented Interfaces:
    Serializable, Map<K,V>, Get<K,V>, IterableGet<K,V>, IterableMap<K,V>, Put<K,V>
  Direct Known Subclasses:
    TransformedSortedMap

      public class TransformedMap<K,V>
      extends AbstractMapDecorator<K,V>
      implements Serializable

  Decorates another `Map` to transform objects that are added.

  The Map put methods and Map.Entry setValue method are affected by this class. Thus objects must be removed or searched for using their transformed form. For example, if the transformation converts Strings to Integers, you must use the Integer form to remove objects.

  Note that TransformedMap is not synchronized and is not thread-safe. If you wish to use this map from multiple threads concurrently, you must use appropriate synchronization. The simplest approach is to wrap this map using `Collections.synchronizedMap(Map)`. This class may throw exceptions when accessed by concurrent threads without synchronization.

  This class is Serializable from Commons Collections 3.1.

  Since:
    3.0
  See Also:
    `TransformedSplitMap`, Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface java.util.Map

      `Map.Entry<K,V>`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Transformer<? super K,? extends K>` | `keyTransformer` The transformer to use for the key
    `protected Transformer<? super V,? extends V>` | `valueTransformer` The transformer to use for the value

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `TransformedMap(Map<K,V> map, Transformer<? super K,? extends K> keyTransformer, Transformer<? super V,? extends V> valueTransformer)` Constructor that wraps (not copies).

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected V` | `checkSetValue(V value)` Override to transform the value when using `setValue`.
    `Set<Map.Entry<K,V>>` | `entrySet()`
    `protected boolean` | `isSetValueChecking()` Override to only return true when there is a value transformer.
    `V` | `put(K key, V value)` Note that the return type is Object, rather than V as in the Map interface.
    `void` | `putAll(Map<? extends K,? extends V> mapToCopy)`
    `static <K,V> TransformedMap<K,V>` | `transformedMap(Map<K,V> map, Transformer<? super K,? extends K> keyTransformer, Transformer<? super V,? extends V> valueTransformer)` Factory method to create a transforming map that will transform existing contents of the specified map.
    `static <K,V> TransformedMap<K,V>` | `transformingMap(Map<K,V> map, Transformer<? super K,? extends K> keyTransformer, Transformer<? super V,? extends V> valueTransformer)` Factory method to create a transforming map.
    `protected K` | `transformKey(K object)` Transforms a key.
    `protected Map<K,V>` | `transformMap(Map<? extends K,? extends V> map)` Transforms a map.
    `protected V` | `transformValue(V object)` Transforms a value.

    - ### Methods inherited from class org.apache.commons.collections4.map.AbstractMapDecorator

      `clear, containsKey, containsValue, decorated, equals, get, hashCode, isEmpty, keySet, remove, size, toString, values`

    - ### Methods inherited from class org.apache.commons.collections4.map.AbstractIterableMap

      `mapIterator`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Map

      `compute, computeIfAbsent, computeIfPresent, forEach, getOrDefault, merge, putIfAbsent, remove, replace, replace, replaceAll`

- - ### Field Detail

    - #### keyTransformer

          protected final Transformer<? super K,? extends K> keyTransformer

      The transformer to use for the key

    - #### valueTransformer

          protected final Transformer<? super V,? extends V> valueTransformer

      The transformer to use for the value

  - ### Constructor Detail

    - #### TransformedMap

          protected TransformedMap(Map<K,V> map,
                                   Transformer<? super K,? extends K> keyTransformer,
                                   Transformer<? super V,? extends V> valueTransformer)

      Constructor that wraps (not copies).

      If there are any elements already in the collection being decorated, they are NOT transformed.

      Parameters:
        `map` - the map to decorate, must not be null
        `keyTransformer` - the transformer to use for key conversion, null means no conversion
        `valueTransformer` - the transformer to use for value conversion, null means no conversion
      Throws:
        `NullPointerException` - if map is null

  - ### Method Detail

    - #### transformingMap

          public static <K,V> TransformedMap<K,V> transformingMap(Map<K,V> map,
                                                                  Transformer<? super K,? extends K> keyTransformer,
                                                                  Transformer<? super V,? extends V> valueTransformer)

      Factory method to create a transforming map.

      If there are any elements already in the map being decorated, they are NOT transformed. Contrast this with `transformedMap(Map, Transformer, Transformer)`.

      Type Parameters:
        `K` - the key type
        `V` - the value type
      Parameters:
        `map` - the map to decorate, must not be null
        `keyTransformer` - the transformer to use for key conversion, null means no transformation
        `valueTransformer` - the transformer to use for value conversion, null means no transformation
      Returns:
        a new transformed map
      Throws:
        `NullPointerException` - if map is null
      Since:
        4.0

    - #### transformedMap

          public static <K,V> TransformedMap<K,V> transformedMap(Map<K,V> map,
                                                                 Transformer<? super K,? extends K> keyTransformer,
                                                                 Transformer<? super V,? extends V> valueTransformer)

      Factory method to create a transforming map that will transform existing contents of the specified map.

      If there are any elements already in the map being decorated, they will be transformed by this method. Contrast this with `transformingMap(Map, Transformer, Transformer)`.

      Type Parameters:
        `K` - the key type
        `V` - the value type
      Parameters:
        `map` - the map to decorate, must not be null
        `keyTransformer` - the transformer to use for key conversion, null means no transformation
        `valueTransformer` - the transformer to use for value conversion, null means no transformation
      Returns:
        a new transformed map
      Throws:
        `NullPointerException` - if map is null
      Since:
        4.0

    - #### transformKey

          protected K transformKey(K object)

      Transforms a key.

      The transformer itself may throw an exception if necessary.

      Parameters:
        `object` - the object to transform
      Returns:
        the transformed object

    - #### transformValue

          protected V transformValue(V object)

      Transforms a value.

      The transformer itself may throw an exception if necessary.

      Parameters:
        `object` - the object to transform
      Returns:
        the transformed object

    - #### transformMap

          protected Map<K,V> transformMap(Map<? extends K,? extends V> map)

      Transforms a map.

      The transformer itself may throw an exception if necessary.

      Parameters:
        `map` - the map to transform
      Returns:
        the transformed object

    - #### checkSetValue

          protected V checkSetValue(V value)

      Override to transform the value when using `setValue`.
      Parameters:
        `value` - the value to transform
      Returns:
        the transformed value
      Since:
        3.1

    - #### isSetValueChecking

          protected boolean isSetValueChecking()

      Override to only return true when there is a value transformer.
      Returns:
        true if a value transformer is in use
      Since:
        3.1

    - #### put

          public V put(K key,
                       V value)

      Description copied from interface: `Put`
      Note that the return type is Object, rather than V as in the Map interface. See the class Javadoc for further info.
      Specified by:
        `put` in interface `Map<K,V>`
      Specified by:
        `put` in interface `Put<K,V>`
      Overrides:
        `put` in class `AbstractMapDecorator<K,V>`
      Parameters:
        `key` - key with which the specified value is to be associated
        `value` - value to be associated with the specified key
      Returns:
        the previous value associated with `key`, or `null` if there was no mapping for `key`. (A `null` return can also indicate that the map previously associated `null` with `key`, if the implementation supports `null` values.)
      See Also:
        `Map.put(Object, Object)`

    - #### putAll

          public void putAll(Map<? extends K,? extends V> mapToCopy)

      Specified by:
        `putAll` in interface `Map<K,V>`
      Specified by:
        `putAll` in interface `Put<K,V>`
      Overrides:
        `putAll` in class `AbstractMapDecorator<K,V>`
      Parameters:
        `mapToCopy` - mappings to be stored in this map
      See Also:
        `Map.putAll(Map)`

    - #### entrySet

          public Set<Map.Entry<K,V>> entrySet()

      Specified by:
        `entrySet` in interface `Map<K,V>`
      Specified by:
        `entrySet` in interface `Get<K,V>`
      Overrides:
        `entrySet` in class `AbstractMapDecorator<K,V>`
      Returns:
        a set view of the mappings contained in this map
      See Also:
        `Map.entrySet()`

Copyright © 2001–2018 The Apache Software Foundation. All rights reserved.